var sqlite3 = require('sqlite3');
var open = require('sqlite').open;
var builder = require('xmlbuilder');
var fs = require('fs')
// var { answer_repository, correct_answer_repository } = require('../repositories')

var repository = {
    create: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let question = await db.run('INSERT INTO question (content, test_id, points, problem_id) VALUES (@content, @test_id, @points, @problem_id)',
            { '@content': entity.content, '@test_id': entity.test_id, '@points': entity.points, '@problem_id': entity.problem_id });

        let obj = {
            'qti-assessment-item': {
                '@xmlns': 'http://www.imsglobal.org/xsd/qti/imsqtiasi_v3p0',
                '@xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
                '@xsi:schemaLocation': 'http://www.imsglobal.org/xsd/imsqtiasi_v3p0 https://www.imsglobal.org/xsd/qti/qtiv3p0/imsqti_itemv3p0_v1p0.xsd',
                '@identifier': '' + question.lastID,
                '@time-dependent': 'false',
                '@xml:lang': 'en-US',
                'qti-response-declaration': {
                    '@base-type': 'identifier',
                    '@cardinality': 'multiple',
                    '@identifier': 'RESPONSE',
                    'qti-correct-response': {}
                },
                'qti-outcome-declaration': {
                    '@base-type': 'float',
                    '@cardinality': 'single',
                    '@identifier': 'SCORE',
                    'qti-default-value': {
                        'qti-value': entity.points
                    }
                },
                'qti-item-body': {
                    'qti-choice-interaction': {
                        '@max-choices': 0,
                        '@response-identifier': 'RESPONSE',
                        'qti-prompt': entity.content
                    }
                },
                'qti-response-processing': {
                    '@template': 'https://purl.imsglobal.org/spec/qti/v3p0/rptemplates/match_correct'
                }
            }
        };

        var root = builder.create(obj);

        for (let i = 0; i < entity.answers.length; i++) {
            let answer = entity.answers[i];
            answer.question_id = question.lastID;

            // Insert new answer
            // let newAnswer = await answer_repository.create(answer);
            var newAnswer = await db.run('INSERT INTO answer (question_id, content) VALUES (@question_id, @content)',
                { '@question_id': answer.question_id, '@content': answer.content });

            root.children[2].children[0].element('qti-simple-choice', { 'identifier': newAnswer.lastID }, answer.content);

            if (answer.isCorrect) {
                // await correct_answer_repository.create({ answer_id: newAnswer.lastID , question_id: question.lastID }); // VERY RISKY!!
                let correct_answer = await db.run('INSERT INTO correct_answer (answer_id, question_id) VALUES (@answer_id, @question_id)',
                    { '@answer_id': newAnswer.lastID, '@question_id': answer.question_id });
                
                root.children[0].children[0].element('qti-value', {}, newAnswer.lastID);
            }
        }

        var xml = root.end({ pretty: true });
        xml = xml.slice(0, 19) + ' encoding="UTF-8"' + xml.slice(19);

        if (!fs.existsSync('./public/items')) {
            fs.mkdirSync('./public/items', { recursive: true });
        }
        fs.writeFile('public/items/item-' + question.lastID + '.xml', xml, {flag: 'w'}, err => { if (err) console.log("GRESKA PRI PISANJU U FAJL"); });

        await db.close();
        return question;
    },
    update: async (entity) => {
        // Updates entity of given id in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let question = await db.run('UPDATE question SET content = @content WHERE id = @id',
            { '@content': entity.content, '@id': entity.id });

        for (let i = 0; i < entity.answers.length; i++) {
            let answer = entity.answers[i];

            // Insert new answer
            if (answer.id != null) {
                await db.run('UPDATE answer SET content = @content WHERE id = @id',
                    { '@content': answer.content, '@id': answer.id });
            } else {
                await db.run('INSERT INTO answer (question_id, content) VALUES (@question_id, @content)',
                { '@question_id': entity.id, '@content': answer.content });
            }

            // Retrieve his id
            var stmt = await db.prepare('SELECT id FROM answer WHERE question_id = @question_id AND content = @content',
            { '@question_id': answer.question_id, '@content': answer.content });

            let newAnswerId = await stmt.get().then(res => res.id);
            await stmt.finalize();

            if (answer.isCorrect) {
                // await correct_answer_repository.create({ answer_id: newAnswer.lastID, question_id: question.lastID }); // VERY RISKY!!
                await db.run('INSERT INTO correct_answer (answer_id, question_id) VALUES (@answer_id, @question_id)',
                    { '@answer_id': newAnswerId, '@question_id': entity.id }); // VERY RISKY!!
            }
        }

        // TODO: delete old answers

        await db.close();
        return question;
    },
    delete: async (id) => {
        // Deletes entity of given id from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let result = await db.run('DELETE FROM question WHERE id = @id',
            { '@id': id });

        await db.close();
        return result;
    },
    exists: async (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM question WHERE id = @id',
            { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close();
        return result != null;
    },
    count: async () => {
        // Returns total number of entities in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM question');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close();
        return result.length;
    },
    findById: async (id) => {
        // Returns entity with given id from db table, null if not existent
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM question WHERE id = @id', { '@id': id });
        let question = await stmt.get();
        await stmt.finalize();

        stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
        let answers = await stmt.all();
        await stmt.finalize();

        question.answers = answers;

        await db.close()
        return question;
    },
    getAll: async () => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM question');

        let questions = await stmt.all();
        await stmt.finalize();

        for (let i = 0; i < questions.length; i++) {
            let question = questions[i];

            stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
            let answers = await stmt.all();
            await stmt.finalize();

            question.answers = answers;
        }

        await db.close()
        return questions;
    },
    getAllForTest: async (testid) => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM question WHERE test_id = @tid', {'@tid': testid});

        let questions = await stmt.all();
        await stmt.finalize();

        // for (let i = 0; i < questions.length; i++) {
        //     let question = questions[i];

        //     stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
        //     let answers = await stmt.all();
        //     await stmt.finalize();

        //     question.answers = answers;
        // }

        await db.close()
        return questions;
    },
    getFirst: async (testId) => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM question WHERE test_id = @test_id limit 1', { '@test_id': testId });

        let question = await stmt.get();
        await stmt.finalize();

        stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
        let answers = await stmt.all();
        await stmt.finalize();

        question.answers = answers;

        await db.close()
        return question;
    },
    getByNumberTemp: async (testId, number) => {
       // Returns all entites from db table
       const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM question WHERE test_id = @test_id limit @number', { '@test_id': testId, '@number': number });

        let questions = await stmt.all();
        let question = questions[questions.length-1];
        await stmt.finalize();

        stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
        let answers = await stmt.all();
        await stmt.finalize();

        question.answers = answers;

        await db.close()
        return question;
    },
    checkQuestion: async(id, answered) => {
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });
        console.log('loolololo')
        console.log(id);
        console.log(answered);
        const stmt = await db.prepare('SELECT answer_id FROM correct_answer WHERE question_id = @question_id',
        { '@question_id': id });

        let correct_answers = await stmt.all();
        await stmt.finalize();
        
        await db.close()
        correct_answers = correct_answers.map(x => x.answer_id);

        console.log(correct_answers);
        console.log('loolololo')
        if (answered.length === correct_answers.length && answered.every(id => correct_answers.includes(id))) {
            return true;
        }
        return false;
    }
}

module.exports = repository;